#include "core.h"
#include "alotalot.h"
#include <assert.h>

namespace nytl {
    struct Frame {
        json::JSON& expr;
        LocalVarValue& result;
        LocalVarValue temp_ret;
        size_t chain_el = 0;

        Frame(json::JSON &expr, LocalVarValue &result)
            : expr(expr),
              result(result) {
        }

        uptr<Frame> toMe(bool returned_from_bottom, global_elem_set_t& global_elems,
                const std::vector<LocalVarValue>& local_vars) {
            if (returned_from_bottom) {
                ASSERT(temp_ret.is_json, "Expression \"[ element ]\" is not allowed");
                assert(temp_ret.JSON_subval);
                // json::JSON
                // todo: make usable const JSON
            } else {
                assert(expr.isDictionary());
                if ((*expr["V"]).isInteger()) {
                    size_t lv_ind = (*expr["V"]).asInteger().get_int();
                    assert(lv_ind < local_vars.size());
                    result = local_vars[lv_ind];
                } else if ((*expr["V"]).isString()) {
                    std::string cur_el_name_str = (*expr["V"]).asString();
                    result = LocalVarValue{false, cur_el_name_str, NULL};
                } else
                    assert(false);
            }
            if (chain_el == (*expr["C"]).)
        }
    };

    LocalVarValue rendering_core_execute_expression(global_elem_set_t& global_elems,
        const std::vector<LocalVarValue>& local_vars, json::JSON& expr) {

    }
}
